//Product:	Donkey Kong HTML - Multi Screen (Nintendo) Simulator
//Version:	4.4
//Started:	27.05.2000
//Last update:	06.02.2003
//Author:		Andrzej Czyz (andrzej.czyz@blindfold.z.pl)
//Website:	www.blindfold.z.pl
//Original:	Nintendo Co. Ltd

var bMarioLever = false;			// if marios hand was moved with lever for a while

var arrBarrels = new Array(28);													// zmienione
var bGameTick = true;
var iBarrelsInitNum;                // how many barrels there will be at init
var iGameSpeed;
var timBarrelsID;

var arrSegments = new Array(5);
var timSegmentsID;

var iKongFrame = 2;
var bKongThrow = false;
var timKongID;

var iHookState;
var timHookID;
var timHookRideID;

var iMarioFrame;
var bMarioJump = false;

var iMarioFrameKill;                // remember marios frame during kill
var timMarioUpID;
var timMarioJumpID;
var timMarioFallID;
var timMarioKillID;

var iScoreCnt=0;
var timScoreID;

var timLoveID;

var iInfoPos=0;
var sInfoMsg='';
var timInfoID;
var bMsgFlash = false;

var arrHiScore = new Array(10);

var sScoreName='';
var iRemapState;
var timInputID;


var iScoreBonus=0;
var iHoldCnt;
var iLivesCnt;

var iGameState = 4;                 // 0-no game-all pictures; 1-gameA; 3-game over; 4-clock; 5-set alarm; 6-high score; 7-keys
var iGameMode = 1;		            // A or B = 0 or 1

var timClockID;

var bAlarm=false;
var prefAlarmMin=0;
var prefAlarmHour=0;

var arrKeyNames = new Array("Up","Down","Left","Right","Jump","StartA","StartB");
var arrKeyCodes = new Array(38,40,37,39,32,49,50);
var arrKeyPress = new Array(7);
var arrKeyTimer = new Array(7);

var sKeyCode = 0;

var arrMsgRemap = new Array('Press key for UP:', 'Press key for DOWN:', 'Press key for LEFT:', 'Press key for RIGHT:', 
							'Press key for JUMP:', 'Press key for START A:', 'Press key for START B:');

var arrAllImages = new Array(
"Crane0","Crane1","Crane2",
"Hook4","Hook5","Hook6","Hook7","Hook8",
"Lever1","Lever2",
"Mario1","Mario2","Mario3","Mario4","Mario5","Mario6","Mario7","Mario8","Mario9","Mario10",
"Mario11","Mario12","Mario13","Mario14","Mario15","Mario16","Mario17","Mario18","Mario19","Mario20","Mario21",
"Mario1up","Mario4up","Mario7up","Mario8up","MarioLever1","MarioLever2",
"BridgeUp0","BridgeUp1","BridgeUp2",
"BridgeDown0","BridgeDown1","BridgeDown2",
"Kong1","Kong2","Kong3","Kong4","Kong1up","Kong2up","Kong3up","Kong1down","Kong2down","Kong3down",
"Life0","Life1","Life2",
"Hol1","Hol2","Hol3","Hol4",
"Seg1","Seg2","Seg3","Seg4","Seg5",
"Bar1","Bar2","Bar3","Bar4","Bar5","Bar6","Bar7","Bar8","Bar9","Bar10",
"Bar11","Bar12","Bar13","Bar14","Bar15","Bar16","Bar17","Bar18","Bar19","Bar20",
"Bar21","Bar22","Bar23","Bar24","Bar25","Bar26","Bar27","Bar28",
"Colon","Num0","Num1","Num2","Num3",
"DayAM","DayPM",
"Game0","Game1",
"Love0","Love1",
"Donkey0","Donkey1","Alarm"
);


function PicShow(id){
	var obj = document.getElementById(id);
	obj.style.visibility = 'visible';
}

function PicHide(id){
	var obj = document.getElementById(id);
	obj.style.visibility = 'hidden';
}

function PicChange(id, name){
	document.images[id].src = name;
}

function PicShowAll(){
    for ( var i in arrAllImages )    PicShow(arrAllImages[i]);
}

function PicHideAll(){
    for ( var i in arrAllImages )    PicHide(arrAllImages[i]);
}

function playsound(soundtoplay){
	if ( document.all ){
		document.all['iesound'].src = 'sfx/' + soundtoplay + '.wav';
	}
}

function PrefsLoad(){
	var tmp;
	for (var i=1;i<10 ;i++ ){
		tmp = getCookie("HiScore"+eval(i));
		if ( tmp == null )  arrHiScore[i] = "...0000";
		else                arrHiScore[i] = tmp;
	}

	tmp = getCookie("alarmH");
	if ( tmp == null )  prefAlarmHour = 0;
	else                prefAlarmHour = parseInt(tmp);

	tmp = getCookie("alarmM");
	if ( tmp == null )  prefAlarmMin = 0;
	else                prefAlarmMin = parseInt(tmp);
}

function PrefsSave(){
	for (var i=1;i<10 ;i++ )	setCookie("HiScore"+eval(i), arrHiScore[i]);

	setCookie("alarmH", prefAlarmHour);
	setCookie("alarmM", prefAlarmMin);
}

function setCookie( name, value, expires, path, domain, secure ){
	var today = new Date();
    expires = new Date( today.getTime() + 28 * 24 * 60 * 60 * 1000 );
	var curCookie = name + "=" + escape(value) +
					((expires) ? "; expires=" + expires.toGMTString() : "") +
					((path) ? "; path=" + path : "") +
					((domain) ? "; domain=" + domain : "") +
					((secure) ? "; secure" : "");
	document.cookie = curCookie;
}

// name - name of the desired cookie
// * return string containing value of specified cookie or null if cookie does not exist
function getCookie(name) {
	var dc = document.cookie;
	var prefix = name + "=";
	var begin = dc.indexOf("; " + prefix);
	if ( begin == -1 ){
		begin = dc.indexOf(prefix);
		if ( begin != 0 ) return null;
	} else {
		begin += 2;
	}
	var end = document.cookie.indexOf(";", begin);
	if (end == -1)	end = dc.length;
	return unescape(dc.substring(begin + prefix.length, end));
}

function MsgShowFlashing(){
	if ( bMsgFlash ){
		bMsgFlash=false	
		document.Info.text.value = '';
	} else {
		bMsgFlash=true;
		document.Info.text.value = sInfoMsg;
	}
}

function initKeys(){
    if ( document.addEventListener ){
        document.addEventListener("keydown",keydown,false);
        document.addEventListener("keyup",keyup,false);
    } else if ( document.attachEvent ){
        document.attachEvent("onkeydown", keydown);
        document.attachEvent("onkeyup", keyup);
    } else {
        document.onkeydown = keydown;
        document.onkeyup = keyup;
	}
}

function suppressdefault(e,flag){
   if ( flag ){
       if ( e.preventDefault )	e.preventDefault();
       if ( e.stopPropagation )	e.stopPropagation();
   }
   return !flag;
}

function keyup(e){
	var input;
	if ( e.which ){                         // Netscape/Firefox/Operafsdf
		input = e.which;
	} else if ( window.event ){             // IE
		//if (!e) e = event;                // tego nawet nie jestem pewien
		input = e.keyCode;
	}
	for (var i=0; i<7; i++){
	    if ( input == arrKeyCodes[i] ){
	        arrKeyPress[i] = false;
	        clearTimeout(arrKeyTimer[i]);
	    }
	}
		switch( input ){
		case arrKeyCodes[3]:
		case arrKeyCodes[2]:
		case arrKeyCodes[0]:
		case arrKeyCodes[1]:
			document.images['Ctrl'].src = 'interface/ctrl.png';
			break;
		case arrKeyCodes[4]:
			document.images['ButJump'].src = 'interface/jmp.png';
			break;
	    case arrKeyCodes[5]:
			//MainGameA();
		    break;
	    case arrKeyCodes[6]:
			//MainGameB();
		    break;
		default:
			break;
	}
}

function keydown(e){
	
	var input;
	if ( e.which ){                         // Netscape/Firefox/Operafsdf
		input = e.which;
	} else if ( window.event ){             // IE
		//if (!e) e = event;                // tego nawet nie jestem pewien
		input = e.keyCode;
	}

    sKeyCode = input;	// do hiscore itp - potem zmienic

	switch( input ){
		case arrKeyCodes[3]:
	        if ( arrKeyPress[3] ) return;
			if ( MarioButtonRight() ){
    	        arrKeyPress[3] = true;
	            arrKeyTimer[3] = setTimeout("arrKeyPress[3] = false;", 200);
			}
			break;
		case arrKeyCodes[2]:
	        if ( arrKeyPress[2] ) return;
			if ( MarioButtonLeft() ){
    	        arrKeyPress[2] = true;
	            arrKeyTimer[2] = setTimeout("arrKeyPress[2] = false;", 200);
			}
			break;
		case arrKeyCodes[0]:
	        if ( arrKeyPress[0] ) return;
			if ( MarioButtonUp() ){
	            arrKeyPress[0] = true;
	            arrKeyTimer[0] = setTimeout("arrKeyPress[0] = false;", 200);
	        }
			break;
		case arrKeyCodes[1]:
	        if ( arrKeyPress[1] ) return;
			if ( MarioButtonDown() ){
	            arrKeyPress[1] = true;
	            arrKeyTimer[1] = setTimeout("arrKeyPress[1] = false;", 200);
	        }
			break;
		case arrKeyCodes[4]:
		    if (arrKeyPress[4]) return;
			if ( MarioButtonJump() ){
			    arrKeyPress[4] = true;
			}
			break;
	    case arrKeyCodes[5]:
		    MainGameA();
		    break;
	    case arrKeyCodes[6]:
		    MainGameB();
		    break;
		default:
			break;
	}
	//   return suppressdefault(e,document.testform.keydown.checked);           // to jest raczej wazne, tyle, ze trzeba poprawic
}

function BarrelsMove(){
	for ( var i=1; i<22; i++ )  arrBarrels[i]  = arrBarrels[i+1];			// zmienione
	if ( arrBarrels[15] == 0 )  arrBarrels[15] = arrBarrels[26];			// zmienione
	if ( arrBarrels[17] == 0 )  arrBarrels[17] = arrBarrels[23];			// zmienione
	for ( var i=23; i<25; i++ ) arrBarrels[i]  = arrBarrels[i+1];			// zmienione
	for ( var i=26; i<28; i++ ) arrBarrels[i]  = arrBarrels[i+1];			// zmienione
	arrBarrels[22] = 0;// zmienione
	arrBarrels[25] = 0;// zmienione
	arrBarrels[28] = 0;// zmienione

	if ( bKongThrow ){
		bKongThrow = false;
		PicHide("Kong"+eval(iKongFrame)+"up");
		PicShow("Kong"+eval(iKongFrame)+"down");
		arrBarrels[22+((3-iKongFrame)*3)] = 1;      // put barrel into: 1=27,2=24,3=21								// zmienione
	}
}

function BarrelsShow(){
	for ( var i=1; i<=28; i++ ){																		// zmienione
		if ( arrBarrels[i] == 0 )   PicHide("Bar"+eval(i));
		else					    PicShow("Bar"+eval(i));
	}
}

// barrels check collision - when mario can get hit from falling barrel
function BarrelsGo(){
	if ( bGameTick ){
	
	    // check collision
	    if ( iMarioFrame>=1 && iMarioFrame<=5 ){
            if ( arrBarrels[iMarioFrame+1] == 1 ){
                if ( bMarioJump )   ScoreAddFast(1);
                else                MarioKill();
            }
        }
        if ( iMarioFrame>=6 && iMarioFrame<=10 ){
            if ( arrBarrels[iMarioFrame+2] == 1 ){
                if ( bMarioJump )   ScoreAddFast(2);
                else                MarioKill();
            }
        }

        if ( iMarioFrame>=13 && iMarioFrame<=15 ){		
			if ( arrBarrels[ 21+((3-(iMarioFrame - 12))*3) ] == 1 )	MarioKill();	//  M13 -> B26, M14->B23, M15->B20		// zmienione
		}
		if ( iMarioFrame == 12 && arrBarrels[15] == 1 )	MarioKill();	// to jest przy chodzeniu w gore i czekaniu				// zmienione

        // move barrels - one more tick	
		if ( bGameTick ){                  // to jest tymczasowe, chodzi o to, zeby beczki po kolizji nie poruszyly sie
		    playsound('barrel');
			BarrelsMove();
			BarrelsShow();
			SpeedAdjust(2);
		}
	}
	timBarrelsID = setTimeout("BarrelsGo()", iGameSpeed);
}

function SpeedAdjust( speed ){
    iGameSpeed -= speed;
	if ( iGameSpeed < 200 )	iGameSpeed = 200;
    if ( iGameSpeed > 800 ) iGameSpeed = 800;
}

// segments move; init first
function SegmentsMove(){
	for ( var i=1; i<5; i++ )   arrSegments[i] = arrSegments[i+1];
	
	if ( iGameMode == 0 ){
		if ( iMarioFrame>5 && iMarioFrame<12 && Math.floor(10*Math.random()) == 0 && arrSegments[4] == 0 ) arrSegments[5] = 1;
		else                                                                                            arrSegments[5] = 0;
	} else {
		if ( Math.floor(8*Math.random()) == 0 && arrSegments[4] == 0 )    arrSegments[5] = 1;
		else                                                                        arrSegments[5] = 0;
	}
}

function SegmentsShow(){
	for ( var i=1; i<=5; i++ ){
		if ( arrSegments[i] == 0 ) PicHide("Seg"+eval(i));
		else                    PicShow("Seg"+eval(i));
	}
}

function SegmentsGo(){
	if ( bGameTick ){
		SegmentsMove();
		SegmentsShow();
		if ( bMarioJump ){
			if ( (arrSegments[3] == 1 && iMarioFrame == 8) || (arrSegments[4] == 1 && iMarioFrame == 7) ){
				clearTimeout(timMarioJumpID);
				MarioKill();
			}
		} else if ( arrSegments[1] == 1 && iMarioFrame == 11 ){
			MarioKill();
		}
	}
	timSegmentsID = setTimeout( "SegmentsGo()", iGameSpeed*2 );
}

// kong move; kong throw
function KongMove(){
	// 0 - nothing
	// 2 - throw
	// 1 - go left
	// 3 - go right
	
	// can kong really make up his mind now
	if ( iKongFrame == 4 || bKongThrow == true ) return;
	
	// how much kong likes to move (in percentage)
	var iKongMoveness = Math.floor(100*Math.random());
	if ( iKongMoveness <= 20 ) return;
	
	// determine next move
	var nextmove = 1+Math.floor(6*Math.random());

	// protect the switch
	//if ( iMarioFrame == 13 && iKongFrame != 1 ) nextmove = 1;
	
	switch ( nextmove ){
		case 2:
			PicShow("Kong"+eval(iKongFrame));
			PicShow("Kong"+eval(iKongFrame)+"up");
			PicHide("Kong"+eval(iKongFrame)+"down");
			bKongThrow = true;
			break;
		case 1:
		case 3:
			if ( iKongFrame != nextmove ){
				PicHide("Kong"+eval(iKongFrame));
				PicHide("Kong"+eval(iKongFrame)+"up");
				PicHide("Kong"+eval(iKongFrame)+"down");
				if ( nextmove == 1 )	iKongFrame--;
				if ( nextmove == 3 )	iKongFrame++;
				PicShow("Kong"+eval(iKongFrame));
				PicShow("Kong"+eval(iKongFrame)+"down");
			}
			break;
	}
};

// kong go
function KongGo(){
	if ( bGameTick ) KongMove();
	timKongID = setTimeout( "KongGo()", iGameSpeed/2 );
}

function LeverBack(){
	bMarioLever = false;
	// move right near swich
	if ( iMarioFrame == 13 ){
		PicShow("MarioLever1");
		PicHide("MarioLever2");
	}
}

function MarioButtonRight(){
	document.images['Ctrl'].src = 'interface/ctrlright.png';
	if ( iGameState==1 ){
		if ( !bMarioJump ){
			if ( iMarioFrame>0 && iMarioFrame<5 ){                              // move right on the lower platform - front
                if ( arrBarrels[iMarioFrame+1] == 1 ){
                    MarioKill();
                } else {
					PicHide("Mario"+eval(iMarioFrame++));
					PicShow("Mario"+eval(iMarioFrame));
					playsound('step');
				}
    			return true;
			} else if ( iMarioFrame>6 && iMarioFrame<11 ){                      // move right on the mid platform - back
				if ( arrBarrels[iMarioFrame+1] == 1 ){
				    MarioKill();
				} else {
					PicHide("Mario"+eval(iMarioFrame--));
					PicShow("Mario"+eval(iMarioFrame));
					playsound('step');
				}
    			return true;
			} else if ( iMarioFrame>12 && iMarioFrame<15 ){                     // move right on the upper platform - front - up barrels
			    if ( iMarioFrame == 13 ){                             // move right near swich
				    if ( bMarioLever )	PicHide("MarioLever2");
				    else				PicHide("MarioLever1");
			    }
				PicHide("Mario"+eval(iMarioFrame++));
				PicShow("Mario"+eval(iMarioFrame));
				playsound('step');
				if ( arrBarrels[ 21+((3-(iMarioFrame - 12))*3) ] == 1 )	MarioKill();			// zmienione
    			return true;
			} else if ( iMarioFrame==15 ){                                // falling from the edge
				iMarioFrame=34;
				PicHide("Mario15");
				MarioFall();
    			return true;
			}
		}
	} else if ( iGameState==5 ){
		prefAlarmMin++;
		if ( prefAlarmMin==60 ) prefAlarmMin=0;
		AlarmShowNum();
	}
    return false;
}

function MarioButtonLeft(){
	document.images['Ctrl'].src = 'interface/ctrlleft.png';
	if ( iGameState==1 ){
		if ( !bMarioJump ){
			if ( iMarioFrame>1 && iMarioFrame<6 ){                              // move left on the lower platform
				if ( arrBarrels[iMarioFrame] == 1 ){
				     MarioKill();
				} else {
					PicHide("Mario"+eval(iMarioFrame--));
					PicShow("Mario"+eval(iMarioFrame));
					playsound('step');
				}
    			return true;
			} else if ( iMarioFrame>5 && iMarioFrame<10 ){                      // move left on the mid platform
                if ( arrBarrels[iMarioFrame+2] == 1 ){
                   MarioKill();
                } else {
					PicHide("Mario"+eval(iMarioFrame++));
					PicShow("Mario"+eval(iMarioFrame));
					playsound('step');
				}
    			return true;
			} else if ( iMarioFrame==13 ){                                // swich on the hook
			    if ( iHookState==0 ){
	                iHookState = 1;
	                HookGo();
			    }
			    if ( bMarioLever == false ){
				    bMarioLever = true;
				    PicHide("MarioLever1");
				    PicShow("MarioLever2");
				    setTimeout("LeverBack()", 200);
			    }
    			return true;
		    } else if ( iMarioFrame>13 && iMarioFrame<16 ){                     // move left on the upper platform
				PicHide("Mario"+eval(iMarioFrame--));
				PicShow("Mario"+eval(iMarioFrame));
				playsound('step');
				if ( iMarioFrame == 13 ){                             // move left near swich
					if ( bMarioLever )	PicShow("MarioLever2");
					else				PicShow("MarioLever1");
				}
				if ( arrBarrels[ 21+((3-(iMarioFrame - 12))*3) ] == 1 )	MarioKill();			// zmienione
    			return true;
			}
		}
	} else if ( iGameState==5 ){
		prefAlarmHour++;
		if ( prefAlarmHour==24 )    prefAlarmHour=0;
		AlarmShowNum();
	}
	return false;
}

function MarioButtonUp(){
	document.images['Ctrl'].src = 'interface/ctrlup.png';
	if ( iGameState==1 ){
		if ( iMarioFrame==5 || iMarioFrame==10 || iMarioFrame==11 || iMarioFrame == 12 ){
			PicHide("Mario"+eval(iMarioFrame++));
			PicShow("Mario"+eval(iMarioFrame));
			playsound('step');
			if ( iMarioFrame == 13 ){                                             // move up near swich
				if ( bMarioLever )	PicShow("MarioLever2");
				else				PicShow("MarioLever1");
			}
			if ( iMarioFrame == 11 && arrSegments[1] == 1 )	MarioKill();
            return true;
		}
	} else if ( iGameState==5 ){
		bAlarm = !bAlarm;
		AlarmShowState();
	}
	return false;
}

function MarioButtonDown(){
	document.images['Ctrl'].src = 'interface/ctrldown.png';
	if ( iGameState==1 ){
		if ( iMarioFrame == 6 || iMarioFrame == 11 || iMarioFrame == 12 || iMarioFrame == 13 ){
		    if ( iMarioFrame == 13 ){                                             // move right near swich
			    if ( bMarioLever )	PicHide("MarioLever2");
			    else				PicHide("MarioLever1");
		    }
			PicHide("Mario"+eval(iMarioFrame--));
			PicShow("Mario"+eval(iMarioFrame));
			playsound('step');
			if ( iMarioFrame == 11 && arrSegments[1] == 1 )	MarioKill();
	        return true;
		}
	} else if ( iGameState==5 ){
		bAlarm = !bAlarm;
		AlarmShowState();
	}
	return false;
}

function MarioButtonJump() {
	document.images['ButJump'].src = 'interface/jmpon.png';
	if ( iGameState==1 ){
		if ( !bMarioJump ){
			if ( iMarioFrame == 0 ){       // mario init
	            clearTimeout(timMarioUpID);
	            MarioUpInitTime();
	            return true;
			} else if ( iMarioFrame==1 || iMarioFrame==4 || iMarioFrame==7 || iMarioFrame==8 ){     // just jump
				PicHide("Mario"+eval(iMarioFrame));
	            PicShow("Mario"+eval(iMarioFrame)+"up");
	            bMarioJump = true;
	            playsound('jump');
				if ( (arrSegments[3] == 1 && iMarioFrame == 8) || (arrSegments[4] == 1 && iMarioFrame == 7) ){
					MarioKill();
				} else {
					timMarioJumpID = setTimeout("MarioJumpDown()", iGameSpeed);
				}
	            return true;
			} else if ( iMarioFrame == 15 ){                                      // jump to the hook
				iMarioFrame = 24; 
				PicHide("Mario15");
				PicShow("Mario16");
				playsound('jump');
				if ( iHookState==2 || iHookState==3 || iHookState==12 || iHookState==13 ){      // zlapalem hak
		            clearTimeout(timHookID);
		            iMarioFrame = 39;
		            PauseAll();
		            MarioHook();
	            } else {                                                                        // czekam na hak
				    timMarioJumpID = setTimeout("MarioEdge()", 500);
				}
	            return true;
			}
			
		}
	}
	return false;
}

// mario init when time has come
function MarioUpInitTime(){
    if ( iMarioFrame == 0 ){
	    iMarioFrame = 1;
	    playsound('jump');
	    PicShow("Mario1");
	    LifeShow();
    }
}

function HookEnd(){
	PicShow("Lever1");
	PicHide("Lever2");
	iHookState = 0; 
}

function HookGo(){
    switch ( iHookState ){
	    case 1:                         // wychylony jak trzeba
		    PicHide("Lever1");
		    PicShow("Lever2");
		    PicHide("Crane0");
		    PicShow("Crane1");
		    PicShow("Hook4");
		    break;
	    case 3:
	    case 13:
		    PicShow("Hook5");
		    PicHide("Hook4");
		    break;
	    case 4:
	    case 14:
		    PicShow("Hook6");
		    PicHide("Hook5");
		    break;
	    case 5:
		    PicShow("Hook7");
		    PicHide("Hook6");
		    break;
	    case 6:
		    PicShow("Hook8");
		    PicHide("Hook7");
		    break;
	    case 8:
		    PicShow("Hook7");
		    PicHide("Hook8");
		    break;
	    case 9:
		    PicShow("Hook6");
		    PicHide("Hook7");
		    break;
	    case 10:
		    PicShow("Hook5");
		    PicHide("Hook6");
		    break;
	    case 11:                            // wychylony jak trzeba
		    PicShow("Hook4");
		    PicHide("Hook5")
		    break;
	    case 15:
		    PicShow("Crane0");
		    PicHide("Crane1");
		    PicHide("Hook6");
		    PicShow("Lever1");
	        PicHide("Lever2");
		    break;
	    case 16:
	        iHookState = 0;
		    return;
		    break;
    }
    if ( iMarioFrame==24 && ( iHookState == 1 || iHookState == 2 || iHookState == 11 || iHookState == 12 ) ){
        clearTimeout(timMarioJumpID);
	    PauseAll();
	    iMarioFrame = 39;
	    MarioHook();
	    return;
    }	
    iHookState++;
    timHookID = setTimeout("HookGo()", 500);
}


function MarioJumpDown(){
	bMarioJump = false;
	PicHide("Mario"+eval(iMarioFrame)+"up");
	PicShow("Mario"+eval(iMarioFrame));
}

function MarioFall(){
	switch (iMarioFrame){
        case 34:
	    	playsound('fall');
    		PauseAll();
		    PicShow("Mario20");
		    break;
	    case 35:
		    playsound('hit');
		    PicShow("Mario21");
		    PicHide("Mario20");
		    break;
	    case 36:
		    PicHide("Mario21");
		    break;
		case 38:
		    MarioLifeLost();
    		return;
    		break;	   
    }
	iMarioFrame++;
	timMarioFallID = setTimeout( "MarioFall()", 500 );
}

// mario is jumping to the hook; check if he reaches; at start mario=24
function MarioEdge(){
	iMarioFrame = 34;
	PicHide("Mario16");
	MarioFall();
}

function MarioHook(){
	switch(iMarioFrame){
        case 39:
    	    PicShow("Mario16");
		    PicShow("Hook4");
		    PicShow("Crane1");
		    break;
		case 40:
           	PicShow("Mario17");
			PicShow("Hook6");
			PicShow("Crane1");
			PicHide("Hook4");
			PicHide("Mario16");
			playsound('step');
		    break;
        case 41:
            PicShow("Mario18");
			PicShow("Crane2");
			PicHide("Crane1");
			PicHide("Hook6");
			PicHide("Mario17");
			PicHide("Hol"+eval(iHoldCnt)); 
			playsound('step');
		    break;
		case 42:
		    ScoreAddCount(20);
		    if (--iHoldCnt != 0)    iMarioFrame = 95;
		    break;
	    // bridge dissaperas...
	    case 46:
	    case 48:
	    case 50:
		    PicHide("BridgeUp0");
		    PicHide("BridgeUp1");
		    PicHide("BridgeUp2");
		    break;
	    case 47:
	    case 49:
	    case 51:
		    PicShow("BridgeUp0");
		    PicShow("BridgeUp1");
		    PicShow("BridgeUp2");
		    break;
        case 52:
            PicShow("BridgeDown0");
		    PicShow("BridgeDown1");
		    PicShow("BridgeDown2");
		    PicHide("BridgeUp0");
		    PicHide("BridgeUp1");
		    PicHide("BridgeUp2");
		    PicShow("Kong4");
		    PicHide("Kong"+eval(iKongFrame));
		    if (bKongThrow)  PicHide("Kong"+eval(iKongFrame)+"up");
			else            PicHide("Kong"+eval(iKongFrame)+"down");
		    iKongFrame = 4;
		    playsound('hit');
		    break;
        case 53:
            PicHide("BridgeDown0");
		    PicHide("BridgeDown1");
		    PicHide("BridgeDown2");
		    break;
        case 54:
		    ScoreAddCount(20);
		    LoveGo();
		    SpeedAdjust(-200);
		    break;
	    case 56:
	        iMarioFrame = 99;
		    break;
	    // move hook to normal
	    case 100:
            PicShow("Mario17");
			PicShow("Crane1");
			PicShow("Hook6");
			PicHide("Crane2");
			PicHide("Mario18");
			playsound('step');
		    break;
	    case 101:
            PicShow("Mario19");
			PicShow("Crane0");
			PicHide("Crane1");
			PicHide("Hook6");
			PicHide("Mario17");
	        PicShow("Lever1");
	        PicHide("Lever2");
	        iHookState = 0;
			playsound('step');
		    break;
	    // once again...
        case 102:
            PicHide("Mario19");
			playsound('step');
			break;
		case 104:
			if ( iHoldCnt == 0 ){ // ew kong == 4
			    PicHide("Kong4");
			    GameSetPlay();
			}
			for ( var i=1; i<5; i++ ) arrBarrels[i] = 0;
			BarrelsShow();
			iMarioFrame = 1;
	        PicShow("Mario1");
	        bGameTick = true;
			playsound('jump');
			return;
		    break;
	}
	iMarioFrame++;
	timHookRideID = setTimeout("MarioHook()", 600);
}

function MarioKill(){
	PauseAll();
	iMarioFrameKill = iMarioFrame;
	iMarioFrame = 100;
	playsound('hit');
	MarioKillGo();
}

function MarioKillGo(){
	iMarioFrame++;
	if ( iMarioFrame == 102 || iMarioFrame == 104 ) {
		if ( bMarioJump )	    PicHide("Mario"+eval(iMarioFrameKill)+"up");
		else                    PicHide("Mario"+eval(iMarioFrameKill));
		// move right near swich
		if ( iMarioFrameKill == 13 ){
			if ( bMarioLever )	PicHide("MarioLever2");			// to chyba tez powinno byc zapamietane na kill
			else				PicHide("MarioLever1");
		}	
		playsound('jump');
	} else if ( iMarioFrame == 103 ){
		if ( bMarioJump )	    PicShow("Mario"+eval(iMarioFrameKill)+"up");
		else                    PicShow("Mario"+eval(iMarioFrameKill));
		// move right near swich
		if ( iMarioFrameKill == 13 ){
			if ( bMarioLever )	PicShow("MarioLever2");			// to chyba tez powinno byc zapamietane na kill
			else				PicShow("MarioLever1");
		}		
		playsound('jump');
	}
	if (iMarioFrame < 108) timMarioKillID = setTimeout("MarioKillGo()", 200);
	else {
		if ( bMarioJump )	bMarioJump = false;
		MarioLifeLost();
	}
}

function PauseAll(){
	bGameTick = false;
}

// hide mario; run all; set up mario to go
function AllInit(){
	iMarioFrame = 0;
    bGameTick = true;
	timMarioUpID = setTimeout("MarioUpInitTime()", 8000);
}

// mario losts his life; check for game over; reset kills; init
function MarioLifeLost(){
	if ( iLivesCnt == 1 ){
		GameOver();
	} else {
		iLivesCnt--;
		SpeedAdjust(-200);
		AllInit();
	}
}

function GameStop(){
	clearTimeout(timBarrelsID);
	clearTimeout(timSegmentsID);
	clearTimeout(timKongID);
	clearTimeout(timHookID);
	clearTimeout(timHookRideID);
	clearTimeout(timMarioUpID);
	clearTimeout(timMarioJumpID);
	clearTimeout(timMarioFallID);
	clearTimeout(timMarioKillID);
	clearTimeout(timScoreID);
	clearTimeout(timLoveID);
	clearTimeout(timClockID);
}

function GameOver(){
	GameStop();
	playsound('over');

	// check if I have a high score
	if (iScoreCnt>parseInt(arrHiScore[9].substring( arrHiScore[9].length-4, arrHiScore[9].length))) {
		iGameState=6;
		HighScoreEdit();
	}
	else MainGameOver();

}

function MainGameOver(){
	iGameState=3;
	InfoTextClear();
	InfoTextHighScores();
	InfoTextStart();
	InfoTextKeys();
	InfoTextIngame();
	InfoTextRoll();
}

function LifeShow(){
    for ( var i = 0; i<3; i++ ){
        if (iLivesCnt-1 > i)    PicShow("Life"+eval(i));
        else                    PicHide("Life"+eval(i));
    }
}

function ScoreShow(){
	if ( iScoreCnt>999 ){
		PicShow("Num0");
		PicChange("Num0", numPre[Math.floor((iScoreCnt/1000))+1].src);
	} else {
		PicHide("Num0");
	}
	if ( iScoreCnt>99 ){
		PicShow("Num1");
		PicChange("Num1", numPre[Math.floor((iScoreCnt%1000/100))+1].src);
	} else {
		PicHide("Num1");
	}
	if ( iScoreCnt>9 ){
		PicShow("Num2");
		PicChange("Num2", numPre[Math.floor((iScoreCnt%100)/10)+1].src);
	} else {
		PicHide("Num2");
	}
	PicShow("Num3");
	PicChange("Num3", numPre[(iScoreCnt%10)+1].src);
}

function ScoreAddCount( points ){
	iScoreBonus = points;
	ScoreGo();
}

function ScoreGo(){
	ScoreAddFast(1);
	iScoreBonus--;
	playsound('bonus');
	if ( iScoreBonus>0 )  timScoreID = setTimeout("ScoreGo()", 100); 
}

function ScoreAddFast(points){
	tmpScore=iScoreCnt;
	iScoreCnt+=points;
	if ( iScoreCnt%1000 >= 300 && tmpScore%1000 < 300 ){
		iLivesCnt++;
		playsound('over');
		LifeShow();
	}
	if ( iScoreCnt>9999 ) iScoreCnt-=10000;
	ScoreShow();
}

function LoveGo(){
	if ( iScoreBonus>0 ){
		if ( iScoreBonus%4 < 2 ){
			PicShow("Love0");
			PicHide("Love1");
		} else {
			PicHide("Love0");
			PicShow("Love1");
		}
		timLoveID = setTimeout("LoveGo()", 80); 
	}
	else {
		PicHide("Love0");
		PicHide("Love1");
	}
}

function TimeShowNumbers( hour, min ){
	if ( ( hour >= 12 && min>=1 ) || hour >= 13 ) { //PM
		hour-=12;
		PicHide("DayAM");
		PicShow("DayPM");
	} else { //AM
		PicShow("DayAM");
		PicHide("DayPM");
	}
	if (hour==0) hour=12;

	if ( hour < 10 ){
		PicHide("Num0");
	} else {
		PicShow("Num0");
		PicChange("Num0", numPre[Math.floor(hour/10)+1].src);
	}
	PicShow("Num1");
	PicChange("Num1", numPre[(hour%10)+1].src);
	PicShow("Num2");
	PicChange("Num2", numPre[Math.floor(min/10)+1].src);
	PicShow("Num3");
	PicChange("Num3", numPre[(min%10)+1].src);

	PicShow("Colon");

}

function TimeShow(){
	var Digital=new Date()
	var hour=Digital.getHours()
	var min=Digital.getMinutes()

	TimeShowNumbers(hour, min);

	if ( bAlarm && hour == prefAlarmHour && min == prefAlarmMin ){
		if ( Digital.getSeconds()%2 ){
			PicHide("Donkey0");
			PicShow("Donkey1");
			playsound('over');
		} else {
			PicShow("Donkey0");
			PicHide("Donkey1");
		}
	}

	timClockID = setTimeout("TimeShow()", 1000)	
}

function AlarmShow(){
	AlarmShowNum();
	timClockID = setTimeout("AlarmShow()", 1000)	
}

function AlarmShowNum(){
	var hour=prefAlarmHour;
	var min=prefAlarmMin;

	TimeShowNumbers(hour, min);
}


// 0-no game-all pictures; 1-gameA; 2-gameB; 3-game over; 4-clock; 5-set alarm; 6-high score
// set the alarm
function MainAlarm(){
	if ( iGameState!=5 ){
        CommonReset();
		PicHideAll();
		AlarmShowState();
		
		iGameState = 5;

	    PicShow("Donkey0");

	    sInfoMsg+='Press Up/down to change alarm on/off. ';
	    sInfoMsg+='Press Left/right to change alarm hour/minute. ';
		InfoTextRoll();
		
		AlarmShow();
	} else {
		MainTime();
	}
}

function MainTime(){
	if ( iGameState==1 || iGameState==4 )    return;
    CommonReset();
	PicHideAll();
	AlarmShowState();

	iGameState = 4;

    sInfoMsg+='                      ';
    sInfoMsg+='Alarm is set at '+eval(prefAlarmHour)+":"+eval(prefAlarmMin);
    sInfoMsg+='        ';
	InfoTextRoll();
	
	TimeShow();
}

function MainReset(){
	if ( iGameState==0 )    return;
    CommonReset();
	PicShowAll();
    
	iGameState = 0;
}

function CommonReset(){
	if ( iGameState==6 )  HighScoreSort(sScoreName, iScoreCnt);   // enter
	if ( iGameState==7 )  KeysRemapExit();              // enter
	//playsound('bonus');
	InfoTextClear();
    GameStop();
}

function GameSetPlay(){         // ustawic 'nowe granie' np kong spadl
	iHoldCnt = 4;

    // kong
	bKongThrow = false;
	iKongFrame = Math.floor(3*Math.random())+1;
	PicShow("Kong"+eval(iKongFrame));
	PicShow("Kong"+eval(iKongFrame)+"down");

    // bridge
   	for ( i=0 ; i<3 ; i++) PicShow("BridgeUp"+eval(i));

    // holdings
	for ( i=1 ; i<=iHoldCnt ; i++) PicShow("Hol"+eval(i));
}

function AlarmShowState(){
	if ( bAlarm )	PicShow("Alarm");
	else			PicHide("Alarm");
}

function GameSetGo(){

	MainReset();
	InfoTextIngame();
	InfoTextRoll();

	PicHideAll();

	AlarmShowState();

    GameSetPlay();
    // variables reset
	iGameState=1;
	iScoreBonus = 0;
	iLivesCnt = 3;
	iScoreCnt = 0;
	iMarioFrame = 0;
	bMarioJump = false;
	iHookState = 0;
	bGameTick = true;               // pozniej sprawdzic co sie pokrywa z allinit i uwaznie zmienic

    // ui
	LifeShow();
	ScoreShow();

    // Hook and Lever
    PicShow("Crane0");
	PicShow("Lever1");

    // game mode
	PicShow("Game"+eval(iGameMode));

    // barrels
	for ( var i=1; i<=28; i++ ) arrBarrels[i] = 0;													// zmienione
	for ( var i=0; i<=iBarrelsInitNum; i++ ) arrBarrels[Math.floor(24*Math.random())+4] = 1;		// zmienione
	BarrelsGo(); 

    // segments
	for ( var i=1; i<=5; i++ ) arrSegments[i] = 0;
	SegmentsGo(); 

	KongGo();                       // byc moze da sie zrobic, zeby kong go zawsze pokazywal konga, ale sie wywolywal co random

    // Mario and GameTick
	AllInit();

}

function MainGameA(){
	if ( iGameState==1 || iGameState==6 || iGameState==7 ) return;

	iGameMode = 0;
	iBarrelsInitNum = 3;
	iGameSpeed = 800;

	GameSetGo();
}

function MainGameB(){
	if ( iGameState==1 || iGameState==6 || iGameState==7 ) return;

	iGameMode = 1;
	iBarrelsInitNum = 4;
	iGameSpeed = 700;

	GameSetGo();
}

function HighScoreEdit(){
	clearTimeout(timInfoID);
	InfoTextClear();
	sInfoMsg = 'Enter your name:';
	document.Info.text.value = sInfoMsg;
	sScoreName='';
	sKeyCode=0;

	HighScoreEditGo();
}

function HighScoreEditGo(){
	var tmpCode = sKeyCode;
	sKeyCode = 0;

	if ( tmpCode != 0 ){
		if ( tmpCode == 13 ){
			HighScoreSort(sScoreName, iScoreCnt); // enter
			return;
		} else {
			if ( sScoreName.length < 10 )	sScoreName += String.fromCharCode(tmpCode);
			if ( tmpCode == 27 || tmpCode == 8 || tmpCode == 46 )	sScoreName = sScoreName.substring(0,sScoreName.length-2); // esc, // backspace, // del
			sInfoMsg = 'Name: '+sScoreName;
		}
	}
	if ( sScoreName.length==0 )	sInfoMsg = 'Enter your name:';
	MsgShowFlashing();
	timInputID = setTimeout("HighScoreEditGo()", 100);
}

function MainKeys(){
	if ( iGameState==7 )	return;
    CommonReset();
	PicShowAll();

	clearTimeout(timInfoID);
	sInfoMsg='';
	document.Info.text.value = sInfoMsg;
	sKeyCode=0;
	iGameState=7;
	iRemapState=0;

	KeysRemap();
}


function KeysRemap(){
	var tmpCode = sKeyCode;
	sKeyCode=0;

	if ( tmpCode != 0 ){
		if ( tmpCode==27 ){
			KeysRemapExit(); // escape
			return;
		} else {
			var bNewKey = true;
			for ( var j=0; j<iRemapState; j++ )	if ( tmpCode == code[j] )	bNewKey = false;

			if ( bNewKey ){
				arrKeyCodes[iRemapState] = tmpCode; 
				iRemapState++;
				if ( iRemapState==7 ){
					KeysRemapExit();
					return;
				}
			}
		}
	}
	sInfoMsg = arrMsgRemap[iRemapState];
	MsgShowFlashing();
	timInputID = setTimeout( "KeysRemap()", 100 );
}

function KeysRemapExit(){
	clearTimeout(timInputID);
	iGameState=3;
	InfoTextClear();
	InfoTextKeys();
	InfoTextHighScores();
	InfoTextStart();
	InfoTextIngame();
	InfoTextRoll();
	Info();
}

function InfoTextKeys(){
	sInfoMsg += '                      ';
	sInfoMsg += 'Keys mapped as follows...        ';
	for ( var i=0; i<7; i++ ){
		//if ( arrKeyCodes[i] == 32 ) sKeyName = 'space';											// zrobic to jakos dobrze
		var sKeyName = eval(arrKeyCodes[i]);
		sInfoMsg += arrKeyNames[i] + ': ' + sKeyName + '        ';
	}
}

// my score -> high score; I assume that I'm at least on last position
function HighScoreSort(hname, hscore) {
	clearTimeout(timInputID);
	var tmp;
	if (hscore<10) var insert=hname+"...000"+eval(hscore);
	else if (hscore<100) var insert=hname+"...00"+eval(hscore);
	else if (hscore<1000) var insert=hname+"...0"+eval(hscore);
	else var insert=hname+"..."+eval(hscore);
	arrHiScore[9]=insert;

	for (i=9; i>1; i--)
		if ( parseInt(arrHiScore[i].substring( arrHiScore[i].length-4, arrHiScore[i].length)) > parseInt(arrHiScore[i-1].substring( arrHiScore[i-1].length-4, arrHiScore[i-1].length)) ) {
			tmp = arrHiScore[i];
			arrHiScore[i] = arrHiScore[i-1];
			arrHiScore[i-1] = tmp;
		}
	MainGameOver();
	Info();
}

function Info(){
	document.Info.text.value = sInfoMsg.substring(iInfoPos, iInfoPos+16);
	iInfoPos++;

	if ( iInfoPos==sInfoMsg.length-16 ) iInfoPos=0;
	timInfoID = setTimeout("Info()", 150);
}

function InfoTextClear(){
	sInfoMsg='';
	iInfoPos=0;
}

function InfoTextRoll(){
	sInfoMsg+=sInfoMsg.substring(0, 16);
	iInfoPos=0;
}

function InfoTextHighScores(){
	sInfoMsg+='                      ';
	sInfoMsg+='High scores so far...';
	sInfoMsg+='                ';
	for ( i=1 ; i<10 ; i++ ) sInfoMsg += '#' +eval(i)+ '...' +arrHiScore[i]+ '        ';
	sInfoMsg+='        ';
}

function InfoTextStart(){
	sInfoMsg+='                      ';
	sInfoMsg+='Welcome to Donkey Kong HTML written by Andrzej Czyz. ';
	sInfoMsg+='Based on Game&Watch Multi Screen "Donkey Kong" Nintendo 1982. ';
	sInfoMsg+='        ';
	sInfoMsg+='Press A button for Game A mode, press B button for Game B mode, ';
	sInfoMsg+='press Time button for Time mode, ';
	sInfoMsg+='press Reset button to reset the game, press Alarm button to set the alarm, press Keys button to remap the control keys. ';
}

function InfoTextIngame(){
	sInfoMsg+='                      ';
	sInfoMsg+='Donkey Kong captured a beautiful girl and carries her into a building under construction. ';
	sInfoMsg+='The brave carpenter, Mario comes to rescue her following them over the girders. ';
	sInfoMsg+='Donkey Kong throws barrels at Mario to stop him. ';
	sInfoMsg+='Knock the girder out from under Donkey Kong to save the girl. ';
}

window.onload = function Loaded(){
	numPre = new Array();
	for ( i=1 ; i<11 ; i++ ){
		numPre[i] = new Image();
		numPre[i].src = "gfx/num"+eval(i-1)+".png";
	}

	PrefsLoad();

	MainReset();
	InfoTextClear();
	InfoTextStart();
	InfoTextKeys();
	InfoTextHighScores();
	InfoTextIngame();
	InfoTextRoll();
	Info();
	initKeys();
}

window.onunload = function Closed(){
	PrefsSave();
}

function Loading(){
	sInfoMsg='Please wait while loading... ';
	InfoTextRoll();
	Info();
}

